/*   */
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>

#define SIZE sizeof(struct sockaddr_in)

void catcher (int sig);
int newsockfd;

main ()
{
  int sockfd;
  char c;
  struct sockaddr_in server = {AF_INET, 7000, INADDR_ANY};
  static struct sigaction act;

  act.sa_handler = catcher;

  sigfillset (&(act.sa_mask));
  sigaction (SIGPIPE, &act, NULL);

  /*     */
  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)
    {
      perror ("  socket");
      exit (1);
    }

  /*      */
  if (bind (sockfd, (struct sockaddr *) &server, SIZE) == -1)
    {
      perror ("  bind");
      exit (1);
    }

  /*    */
  if (listen (sockfd, 5) == -1)
    {
      perror ("  listen");
      exit (1);
    }

  for (;;)
    {
      /*     */
      if ((newsockfd = accept (sockfd, NULL, NULL)) == -1)
	{
	  perror ("  accept");
	  continue;
	}

      /*        */
      if (fork () == 0)
	{
	  while (recv (newsockfd, &c, 1, 0) > 0)
	    {
	      c = toupper (c);
	      send (newsockfd, &c, 1, 0);
	    }

	  /*  ,     ,
	   *       
	   *   */
	  close (newsockfd);
	  exit (0);
	}

      /*    newsockfd   */
      close (newsockfd);
    }
}

void 
catcher (int sig)
{
  close (newsockfd);
  exit (0);
}
