/*        */
#include <stdio.h>
#include <string.h>

#include "list.h"

char *strings[] =
{"again", "world", "Hello"};

#define MAXLEN 255		/*     */
#define MAXCMD 100		/*    */
#define ERROR (-1)
#define SUCCESS 0

/* getlist --        */
int 
getlist (char *namepart, char dirnames[][MAXLEN + 1],
	 int maxnames)
{
  char cmd[MAXCMD + 1], in_line[MAXLEN + 2];
  int i;
  FILE *lsf;

  /*   */
  strcpy (cmd, "ls ");
  /*   
   */
  if (namepart != NULL)
    strncat (cmd, namepart, MAXCMD - strlen (cmd));
  if ((lsf = popen (cmd, "r")) == NULL)		/*   */
    return (ERROR);
  for (i = 0; i < maxnames; i++)
    {
      if (fgets (in_line, MAXLEN + 2, lsf) == NULL)
	break;
      /*     */
      if (in_line[strlen (in_line) - 1] == '\n')
	in_line[strlen (in_line) - 1] = '\0';
      strcpy (&dirnames[i][0], in_line);
    }
  if (i < maxnames)
    dirnames[i][0] = '\0';
  pclose (lsf);
  return (SUCCESS);
}

       /*  free_list --     */
void 
free_list (MEMBER ** head)
{
  MEMBER *curr, *next;

  for (curr = *head; curr != (MEMBER *) 0; curr = next)
    {
      next = curr->m_next;
      /*  ,   */
      free ((void *) curr->m_data);
      /*  ,     */
      free ((void *) curr);
    }
  /*      */
  *head = (MEMBER *) 0;
}

/*  new_member --      */
MEMBER *
new_member (char *data)
{
  MEMBER *newmem;

  if ((newmem = (MEMBER *) malloc (sizeof (MEMBER))) == (MEMBER *) 0)
    fprintf (stderr, "new_member:  \n");
  else
    {
      /*      */
      newmem->m_data = (char *) malloc (strlen (data) + 1);
      /*     */
      strcpy (newmem->m_data, data);
      /*     */
      newmem->m_next = (MEMBER *) 0;
    }
  return (newmem);
}

/*  add_member --    MEMBER */
void 
add_member (MEMBER ** head, MEMBER * newmem)
{
  /*     
   *    
   */
  newmem->m_next = *head;
  *head = newmem;
}

main ()
{
  MEMBER *head, *newm;
  int j;

  /*   */
  head = (MEMBER *) 0;
  /*     */
  for (j = 0; j < 3; j++)
    {
      newm = new_member (strings[j]);
      add_member (&head, newm);
    }
  /*    */
  printlist (head);
  /*   */
  free_list (&head);
  /*    */
  printlist (head);
}
       /*     */
void 
printlist (MEMBER * listhead)
{
  MEMBER *m;

  printf ("\n :\n");
  if (listhead == (MEMBER *) 0)
    printf ("\t()\n");
  else
    for (m = listhead; m != (MEMBER *) 0; m = m->m_next)
      printf ("\t%s\n", m->m_data);
}
