/*  status2 --   
 *      waitpid
 */
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>

int
fatal (char *s)
{
  perror (s);
  exit (1);
}

main ()
{
  pid_t pid;
  int status, exit_status;

  if ((pid = fork ()) < 0)
    fatal ("  fork ");

  if (pid == 0)			/*  */
    {
      /*    sleep
       *     4 
       */
      printf (" %d ...\n", getpid ());
      sleep (4);
      exit (5);			/*     */
    }

  /*    ,     */
  /* ,    ,   ,  */
  /*    ,         */
  while (waitpid (pid, &status, WNOHANG) == 0)
    {
      printf (" ...\n");
      sleep (1);
    }

  /*      */
  if (WIFEXITED (status))
    {
      exit_status = WEXITSTATUS (status);
      printf ("  %d  %d\n", pid, exit_status);
    }

  exit (0);
}
