#include <stdio.h>
#include <signal.h>

#define TIMEOUT 5		/*    */
#define MAXTRIES 5		/*   */
#define LINESIZE 100		/*   */
#define CTRL_G '\007'		/* ASCII    */
#define TRUE 1
#define FALSE 0

/* , ,     */
static int timed_out;
/* ,      */
static char answer[LINESIZE];

char *
quickreply (char *prompt)
{
  void catch (int);
  int ntries;
  static struct sigaction act, oact;

  /*   SIGALRM     */
  act.sa_handler = catch;
  sigaction (SIGALRM, &act, &oact);
  for (ntries = 0; ntries < MAXTRIES; ntries++)
    {
      timed_out = FALSE;
      printf ("\n%s > ", prompt);
      /*   */
      alarm (TIMEOUT);
      /*    */
      gets (answer);
      /*   */
      alarm (0);
      /*   timed_out  TRUE,   */
      if (!timed_out)
	break;
    }
  /*    */
  sigaction (SIGALRM, &oact, NULL);
  /*    */
  return (ntries == MAXTRIES ? ((char *) 0) : answer);
}

/*     SIGALRM */
void 
catch (int sig)
{
  /*   timed_out */
  timed_out = TRUE;
  /*    */
  putchar (CTRL_G);
}

void 
main ()
{
  printf ("\n%s", quickreply ("Reply"));
}
