#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>

int 
fatal (char *s)
{
  perror (s);
  exit (1);
}

main ()
{
  pid_t pid;
  int status, exit_status, sig_no;

  if ((pid = fork ()) < 0)
    fatal ("  fork ");
  if (pid == 0)			/*  */
    {
      /*    sleep
       *     20 
       */
      printf (" %d,  20  ...\n", getpid ());
      sleep (20);
      exit (5);			/*     */
    }
  /*    ,     */
  if ((pid = wait (&status)) == -1)
    {
      perror ("  wait");
      exit (1);
    }
  /*      */
  if (WIFEXITED (status))
    {
      exit_status = WEXITSTATUS (status);
      printf ("  %d  %d\n", pid, exit_status);
    }
  /* ,      */
  if (WIFSIGNALED (status))
    {
      sig_no = WTERMSIG (status);
      printf ("  %d   %d\n", sig_no, pid);
      if (WCOREDUMP (status))
	{
	  printf ("...    \n");
	}
    }
  /*    . */
  if (WIFSTOPPED (status))
    {
      sig_no = WSTOPSIG (status);
      printf ("  %d   %d\n", sig_no, pid);
    }
  exit (0);
}
