/*  etest --     . */
#include <stdio.h>
#include <stdlib.h>
#include "q.h"

int 
warn (char *s)
{
  fprintf (stderr, ": %s\n", s);
}

/*   --    */
int 
init_queue (void)
{
  int queue_id;

  /*       */
  if ((queue_id = msgget (QKEY, IPC_CREAT | QPERM)) == -1)
    perror ("  msgget");
  return (queue_id);
}

       /*  enter --     */
int 
enter (char *objname, int priority)
{
  int len, s_qid;
  struct q_entry s_entry;	/*     */

  /*       */
  if ((len = strlen (objname)) > MAXOBN)
    {
      warn ("  ");
      return (-1);
    }
  if (priority > MAXPRIOR || priority < 0)
    {
      warn ("  ");
      return (-1);
    }

  /*   ,    */
  if ((s_qid = init_queue ()) == -1)
    return (-1);
  /*    s_entry */
  s_entry.mtype = (long) priority;
  strncpy (s_entry.mtext, objname, MAXOBN);
  /*  ,  ,    */
  if (msgsnd (s_qid, &s_entry, len, 0) == -1)
    {
      perror ("  msgsnd");
      return (-1);
    }
  else
    return (0);
}

main (int argc, char **argv)
{
  int priority;
  if (argc != 3)
    {
      fprintf (stderr, ": %s  \n", argv[0]);
      exit (1);
    }
  if ((priority = atoi (argv[2])) <= 0 || priority > MAXPRIOR)
    {
      warn (" ");
      exit (2);
    }
  if (enter (argv[1], priority) < 0)
    {
      warn ("   enter");
      exit (3);
    }
  exit (0);
}
