/*  stest --     */
#include <stdio.h>
#include "q.h"

int 
warn (char *s)
{
  fprintf (stderr, ": %s\n", s);
}

/*   --    */
int 
init_queue (void)
{
  int queue_id;

  /*       */
  if ((queue_id = msgget (QKEY, IPC_CREAT | QPERM)) == -1)
    perror ("  msgget");
  return (queue_id);
}

/*  serve --     
 *     
 */
int 
serve (void)
{
  int mlen, r_qid;
  struct q_entry r_entry;
 
  /*   ,    */
  if ((r_qid = init_queue ()) == -1)
    return (-1);

  /*      */
  for (;;)
    {
      if ((mlen = msgrcv (r_qid, &r_entry, MAXOBN,
			  (-1 * MAXPRIOR), MSG_NOERROR)) == -1)
	{
	  perror ("  msgrcv");
	  return (-1);
	}
      else
	{
	  /* ,    */
	  r_entry.mtext[mlen] = '\0';
	  /*    */
	  proc_obj (&r_entry);
	}
    }
}

main ()
{
  pid_t pid;

  switch (pid = fork ())
    {
    case 0:			/*   */
      serve ();
      break;			/*    */
    case -1:
      warn ("   ");
      break;
    default:
      printf ("    %d\n", pid);
    }
  exit (pid != -1 ? 0 : 1);
}

int 
proc_obj (struct q_entry *msg)
{
  printf ("\n: %ld : %s\n", msg->mtype, msg->mtext);
}
