/*  tscript   */
#if !defined(__linux__)
#include "tscript.h"

struct termios dattr;

void 
script (int mfd)
{
  int nread, ofile;
  fd_set set, master;
  struct termios attr;
  char buf[512];

  /*         */
  tcgetattr (0, &attr);
  attr.c_cc[VMIN] = 1;
  attr.c_cc[VTIME] = 0;
  attr.c_lflag &= ~(ISIG | ECHO | ICANON);
  tcsetattr (0, TCSAFLUSH, &attr);

  /*    */
  ofile = open ("output", O_CREAT | O_WRONLY | O_TRUNC, 0666);

  /*       select */
  FD_ZERO (&master);
  FD_SET (0, &master);
  FD_SET (mfd, &master);

  /*  select   ,
   *      . */
  while (set = master, select (mfd + 1, &set, NULL, NULL, NULL) > 0)
    {
      /*    */
      if (FD_ISSET (0, &set))
	{
	  nread = read (0, buf, 512);
	  write (mfd, buf, nread);
	}
      /*    */
      if (FD_ISSET (mfd, &set))
	{
	  nread = read (mfd, buf, 512);
	  write (ofile, buf, nread);
	  write (1, buf, nread);
	}
    }
}

void 
runshell (int sfd)
{
  setpgrp ();
  dup2 (sfd, 0);
  dup2 (sfd, 1);
  dup2 (sfd, 2);
  execl ("/bin/sh", "sh", "-i", (char *) 0);
}

int 
pttyopen (int *masterfd, int *slavefd)
{
  char *slavenm;

  /*   -
   *      */
  if ((*masterfd = open ("/dev/ptmx", O_RDWR)) == -1)
    return (-1);
  /*       */
  if (grantpt (*masterfd) == -1)
    {
      close (*masterfd);
      return (-2);
    }
  /*   ,   mfd */
  if (unlockpt (*masterfd) == -1)
    {
      close (*masterfd);
      return (-3);
    }
  /*         */
  if ((slavenm = ptsname (*masterfd)) == NULL)
    {
      close (*masterfd);
      return (-4);
    }
  if ((*slavefd = open (slavenm, O_RDWR)) == -1)
    {
      close (*masterfd);
      return (-5);
    }
  /*     */
  if (ioctl (*slavefd, I_PUSH, "ptem") == -1)
    {
      close (*masterfd);
      close (*slavefd);
      return (-6);
    }
  if (ioctl (*slavefd, I_PUSH, "ldterm") == -1)
    {
      close (*masterfd);
      close (*slavefd);
      return (-7);
    }
  return (1);
}

void 
catch_child (int signo)
{
  tcsetattr (0, TCSAFLUSH, &dattr);
  exit (0);
}

main ()
{
  struct sigaction act;
  int mfd, sfd, err;
  char buf[512];

  /*     */
  tcgetattr (0, &dattr);
  /*   */
  if ((err = pttyopen (&mfd, &sfd)) != 1)
    {
      fprintf (stderr, "pttyopen: %d\n", err);
      perror ("   ");
      exit (1);
    }
  /*    SIGCHLD */
  act.sa_handler = catch_child;
  sigfillset (&(act.sa_mask));
  sigaction (SIGCHLD, &act, NULL);
  /*    */
  switch (fork ())
    {
    case -1:			/*  */
      perror ("  ");
      exit (2);
    case 0:			/*   */
      close (mfd);
      runshell (sfd);
    default:			/*   */
      close (sfd);
      script (mfd);
    }
}
#else
void main ()
{
printf("      Linux\n");
}
#endif